//
//  Paint.m
//
//  Created by Ivan Mao on 12-8-22.
//  Copyright 2012 PQ Labs. All rights reserved.
//

#import "Paint.h"

static void drawAnX(CGContextRef gc)
{
    CGPoint p;
	
    p = CGContextGetPathCurrentPoint(gc);
    CGContextMoveToPoint(gc, p.x+3, p.y+3);
    CGContextAddLineToPoint(gc, p.x-3, p.y-3);
    CGContextMoveToPoint(gc, p.x+3, p.y-3);
    CGContextAddLineToPoint(gc, p.x-3, p.y+3);
    CGContextStrokePath(gc);
}

@implementation Paint

Paint * pencil;


-(void)drawRect:(NSRect)dirtyRect
{
	int i;
	
	paintSize = [self frame];	
	pencil = self;
	CGRect frameRect;

    CGRect pageRect;
    CGContextRef context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
	
	frameRect.origin.x = dirtyRect.origin.x;
	frameRect.origin.y = dirtyRect.origin.y;
	frameRect.size.width = dirtyRect.size.width;
	frameRect.size.height = dirtyRect.size.height;
	CGContextAddRect (context, frameRect);
	CGContextStrokePath(context);

    
    pageRect = CGRectMake(dirtyRect.origin.x, dirtyRect.origin.y, dirtyRect.size.width, dirtyRect.size.height);
	
    CGContextBeginPage(context, &pageRect);
	
	for(i = 0; i < curTouchPointNum; i++)
	{
		CGContextMoveToPoint(context, myPoint[i].x, myPoint[i].y);
		drawAnX(context);
	}
}

-(void)addMyTouchPoint:(int)sid
{
	if(curTouchPointNum < TOUCH_POINT_MAX_NUM)
	{
		TouchPointList[curTouchPointNum] = sid;
	
		curTouchPointNum ++;
	}
}

-(void)deleteMyTouchPoint:(int)sid
{
	int i;
	for(i=0; i< curTouchPointNum; i++)
	{
		if(TouchPointList[i] == sid)
		{
			if (i != TOUCH_POINT_MAX_NUM - 1) {
				memcpy(&TouchPointList[i], &TouchPointList[i+1], sizeof(int)*(TOUCH_POINT_MAX_NUM - i - 1));
				memcpy(&myPoint[i], &myPoint[i+1], sizeof(NSPoint)*(TOUCH_POINT_MAX_NUM - i - 1));
				memset(&myPoint[TOUCH_POINT_MAX_NUM-1], 0, sizeof(NSPoint));
			}
			
			curTouchPointNum --;
			break;
		}
	}
	
}

-(void)drawMyTouchPoint:(NSPoint)pt :(int)sid
{	
	int i;
	
	for(i=0; i<curTouchPointNum; i++)
	{
		if (TouchPointList[i] == sid) {
			myPoint[i] = [self getActualPoint:pt];
			break;
		}
	}
	
	[self setNeedsDisplay:YES];
}

-(void)getResolution:(int)x :(int)y
{
	screenX = x;
	screenY = y;
}

-(NSPoint)getActualPoint:(NSPoint)pt
{
	NSPoint tmp = pt;
	tmp.x = paintSize.size.width * pt.x / screenX;
	tmp.y = paintSize.size.height * pt.y / screenY;
	
	tmp.y = paintSize.size.height - tmp.y;
	
	return tmp;
}

@end
